#ifndef ANDROIDMANIFESTFILE_H_
#define ANDROIDMANIFESTFILE_H_

#include <set>
#include "filetarget.h"

class AndroidApplicationComponent;
class SharedLibrary;

/**
Metadata file for an Android application.
*/
class AndroidManifestFile: public FileTarget
{
private:
	SharedLibrary *native_lib;
	std::set<std::string> permissions;

public:
	AndroidManifestFile(Builder &, const AndroidApplicationComponent &);

	virtual const char *get_type() const { return "AndroidManifestFile"; }

	void set_native_library(SharedLibrary *);
	SharedLibrary *get_native_library() const { return native_lib; }

	void add_permission(const std::string &);
	const std::set<std::string> &get_permissions() const { return permissions; }
};

#endif
