#ifndef CSOURCEFILE_H_
#define CSOURCEFILE_H_

#include <msp/io/base.h>
#include "sourcefile.h"

/**
Represents a C or C++ source file.
*/
class CSourceFile: public SourceFile
{
public:
	typedef std::list<std::string> IncludeList;

protected:
	IncludeList includes;

public:
	CSourceFile(Builder &, const Msp::FS::Path &);
	CSourceFile(Builder &, const Component &, const Msp::FS::Path &);

	virtual const char *get_type() const { return "CSourceFile"; }
	const IncludeList &get_includes() const { return includes; }
protected:
	virtual void parse_includes(Msp::IO::Base &);
	virtual void find_dependencies();
	virtual void modified();
};

#endif
